program fake_xpfm;

{$m 16384,0,0}

uses dos;

const maxutil=25;

      meldung1='FakeXPFM v0.1 (c) 1998 by Robert Boeck@2:2480/31.37';
      meldung2='-= Freeware =-            Robert.Boeck@munich.netsurf.de';
      meldung3='                          robo@muenchen.org';

      crlf=#13#10;

      cfgname='FAKEXPFM.CFG';

{     Fehlercodes von XP-FM:

      0 = Connect + bertragung erfolgreich
      1 = Senden ok, aber Fehler beim Empfangen
      2 = Fehler beim Senden
      3 = kein CONNECT
      4 = CONNECT, aber kein erfolgreiches Login
      5 = Abbruch mit <Esc>, bevor CONNECT zustande kam
      8 = Carrier-Signal bei Programmstart vorhanden
      9 = Parameter-Fehler
}

      err_xpfm_OK    = 0;
      err_xpfm_Rx    = 1;
      err_xpfm_Tx    = 2;
      err_xpfm_conn  = 3;
      err_xpfm_login = 4;
      err_xpfm_esc   = 5;
      err_xpfm_dcd   = 8;
      err_xpfm_param = 9;


var utilities:array[1..maxutil] of string;
    nr_util:word;


function exist(d:string):boolean;
  var f:file;
  begin
    assign(f,d);
    {$i-} reset(f); {$i+}
    if ioresult=0 then begin
      close(f);
      exist:=true;
    end
    else exist:=false;
  end;

procedure errorhalt(s:string;errlev:byte);
  begin
    writeln(s);
    halt(errlev);
  end;

procedure delspace(var s:string);
  begin
    while (length(s)>0) and ((s[1]=' ') or (s[1]=#9)) do delete(s,1,1);
    while (length(s)>0) and ((s[length(s)]=' ') or (s[length(s)]=#9))
     do dec(byte(s[0]));
  end;

procedure get_cfg;
  var f_cfg:text;
      zeile:string;

  procedure fehler(s:string;errlev:byte;close_cfg:boolean);
    begin
      if close_cfg then close(f_cfg);
      errorhalt('Fehler: '+s,errlev);
    end;

  begin
    nr_util:=0;
    if not exist(cfgname)
     then fehler(cfgname+' nicht gefunden.',err_xpfm_conn,false);
    assign(f_cfg,cfgname);
    reset(f_cfg);
    while not eof(f_cfg) do begin
      readln(f_cfg,zeile);
      delspace(zeile);
      if (length(zeile)>0) and not (zeile[1] in [';',#39,'#']) then begin
        if nr_util=maxutil
         then fehler('Zu viele Eintrge in '+cfgname,err_xpfm_conn,true);
        inc(nr_util);
        if not exist(zeile)
         then fehler(zeile+' nicht gefunden.',err_xpfm_conn,true);
        utilities[nr_util]:=zeile;
      end;
    end;
    close(f_cfg);
  end;

var i,lastexitcode:word;
    parameter:string;

begin
  writeln(meldung1,crlf,meldung2,crlf,meldung3,crlf);
  parameter:='';
  for i:=1 to paramcount do parameter:=parameter+' '+paramstr(i);
  get_cfg;
  if nr_util=0
   then errorhalt('Fehler: Keine Eintrge in '+cfgname,err_xpfm_conn);
  lastexitcode:=err_xpfm_conn;
  for i:=1 to nr_util do begin
    writeln('Starte ',utilities[i],' ...');
    swapvectors;
    exec(utilities[i],parameter);
    swapvectors;
    write(utilities[i],' beendet, ');
    if doserror<>0 then begin
      writeln('DOS Error ',doserror);
      lastexitcode:=err_xpfm_conn;
    end
    else begin
      lastexitcode:=dosexitcode;
      writeln('DOS Exit Code = ',lastexitcode);
    end;
  end;
  halt(lastexitcode);
end.
